EDIT - task #6226

Delete orphaned key nodes
11/28/2016 01:39 PM - Andreas Muller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 100%
Category: data Estimated time: 0:00 hour
Target version: CDM UML 4.7

Severity: normal

Description

As deletion did not work correctly for long time we do still have PolytomousKeyNodes that do reference a PolytomousKey that does
not exist anymore in the database (due to missing referential integrity checking).

These need to be deleted via update script.

he-same-may-be-truefor-othertree-nrodes{TaxonNede,FeatureNede} => checked this, taxon node and feature node do not seem
to be critical, didn't find any example, maybe taxon nodes where deleted previously already

Related issues:
Copied to EDIT - bug #6705: Remove remaining orphaned PolytomousKeyNodes New

Associated revisions

Revision 38dc3727 - 06/05/2017 04:51 PM - Andreas Miiller
fix #6226 delete orphaned keys and key statements

History

#1 - 11/28/2016 01:40 PM - Andreas Miuller

SELECT *
FROM PolytomousKeyNode pkn
WHERE pkn.key_id NOT IN (SELECT id FROM PolytomousKey) ;

#2 - 12/01/2016 01:48 PM - Andreas Miiller
- Target version changed from CDM UML 4.1 to Release 4.6

#3 - 12/01/2016 01:59 PM - Andreas Miiller
- Target version changed from Release 4.6 to COM UML 4.7

#4 - 06/05/2017 12:43 PM - Andreas Miiller
- Priority changed from New to Highest

#5 - 06/05/2017 04:48 PM - Andreas Miller

Also need to delete orphaned key statements

#6 - 06/05/2017 04:49 PM - Andreas Miller

- Tracker changed from bug to task

#7 - 06/05/2017 04:52 PM - Andreas Miiller
- Description updated
- Status changed from New to Resolved

- % Done changed from 0 to 50

#8 - 06/08/2017 08:11 AM - Andreas Miiller
- Copied to bug #6705: Remove remaining orphaned PolytomousKeyNodes added
#9 - 06/08/2017 08:12 AM - Andreas Miiller

- Status changed from Resolved to Closed

| checked with

SELECT *
FROM PolytomousKeyNode pkn
WHERE pkn.key_id NOT IN (SELECT id FROM PolytomousKey) ;

SELECT *

FROM PolytomousKeyNode pkn

WHERE pkn.question_id NOT IN (SELECT ks.id FROM KeyStatement ks) or
pkn.statement_id NOT IN (SELECT ks.id FROM KeyStatement ks);

SELECT *
FROM KeyStatement ks
WHERE id NOT IN (SELECT MN.KeyStatement_id FROM KeyStatement_LanguageString MN );

SELECT *
FROM KeyStatement_LanguageString MN
WHERE MN.label_id NOT IN (SELECT id FROM LanguageString LS ) ;

didn't find any unlinked records except for those being there before already (e.g. in cyprus KeyStatement.id = 2613 which has not LanguageString) =>
deleted this in production as it is not in the key anymore.

So there are some more orphaned key nodes that have no parent but are also no root nodes. This is handled in new #6705

#10 - 06/08/2017 08:12 AM - Andreas Miiller
- % Done changed from 50 to 100
